#include <stdio.h>
#include <pthread.h>

typedef unsigned char bool;
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef __cplusplus
extern "C" {
#endif

#define TESTSTRING "This is a test.  I am ok."

void foo(void *arg) {
    char *bar;
    int i, j, x;

    for (i = 0; i < 1000000; ++i) {
	bar = (char*)malloc(26 * sizeof(char));
	strcpy(bar, TESTSTRING);
	for (x = 0, j = 0; j < 1000; ++j) {
	    x += j;
	}
	if (strcmp(bar, TESTSTRING)) {
	    printf("bar is %s, i = %d\n", bar, i);
	}
	free(bar);
    }
}

int tt_run() {
    pthread_t *threads;
    int i, tc = 2; 

    printf ("tc is %d\n", tc);
    threads = (pthread_t*)malloc(tc * sizeof(pthread_t));
    for (i = 0; i < tc; ++i) {
	pthread_create(&threads[i], NULL, (void*)foo, NULL);
    }

    for (i = 0; i < tc; ++i) {
	pthread_join(threads[i], NULL);
    }

    return 0;
}

#ifdef __cplusplus
}
#endif

MODULE = TT	PACKAGE = TT	PREFIX = TT_

void
TT_doit ()
    CODE:
	tt_run();

